Package weka.filters.unsupervised.attribute

# Class AddValues

java.lang.Object
weka.filters.Filter
weka.filters.unsupervised.attribute.AddValues

All Implemented Interfaces:
  `Serializable`, `CapabilitiesHandler`, `OptionHandler`, `RevisionHandler`, `StreamableFilter`, `UnsupervisedFilter`

public class AddValues extends Filter implements UnsupervisedFilter, StreamableFilter, OptionHandler
Adds the labels from the given list to an attribute if they are missing. The labels can also be sorted in an ascending manner. If no labels are provided then only the (optional) sorting applies.

Valid options are:

     -C <col>
      Sets the attribute index
      (default last).

     -L <label1,label2,...>
      Comma-separated list of labels to add.
      (default: none)

     -S
      Turns on the sorting of the labels.

Based on code from AddValues.

Version:
  $Revision: 6897 $
Author:
  FracPete (fracpete at waikato dot ac dot nz)
See Also:
  - `AddValues`
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`AddValues()`

## Method Summary

Modifier and Type
Method
Description
`String`
`attributeIndexTipText()`
Returns the tip text for this property
`String`
`getAttributeIndex()`
Get the index of the attribute used.
`Capabilities`
`getCapabilities()`
Returns the Capabilities of this filter.
`String`
`getLabels()`
Get the comma-separated list of labels that are added.
`String[]`
`getOptions()`
Gets the current settings of the filter.
`String`
`getRevision()`
Returns the revision string.
`boolean`
`getSort()`
Gets whether the labels are sorted or not.
`String`
`globalInfo()`
Returns a string describing this filter
`boolean`
`input(Instance instance)`
Input an instance for filtering.
`String`
`labelsTipText()`
Returns the tip text for this property
`Enumeration`
`listOptions()`
Returns an enumeration describing the available options.
`static void`
`main(String[] args)`
Main method for testing and running this class.
`void`
`setAttributeIndex(String attIndex)`
Sets index of the attribute used.
`boolean`
`setInputFormat(Instances instanceInfo)`
Sets the format of the input instances.
`void`
`setLabels(String value)`
Sets the comma-separated list of labels.
`void`
`setOptions(String[] options)`
Parses a given list of options.
`void`
`setSort(boolean value)`
Sets whether the labels are sorted.
`String`
`sortTipText()`
Returns the tip text for this property

### Methods inherited from class weka.filters.Filter

`batchFilterFile, batchFinished, filterFile, getCapabilities, getOutputFormat, isFirstBatchDone, isNewBatch, isOutputFormatDefined, makeCopies, makeCopy, numPendingOutput, output, outputPeek, toString, useFilter, wekaStaticWrapper`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### AddValues

public AddValues()

## Method Details

### globalInfo

public String globalInfo()
Returns a string describing this filter

Returns:
  a description of the filter suitable for displaying in the explorer/experimenter gui

### listOptions

public Enumeration listOptions()
Returns an enumeration describing the available options.

Specified by:
  `listOptions` in interface `OptionHandler`
Returns:
  an enumeration of all the available options.

### setOptions

public void setOptions(String[] options) throws Exception
Parses a given list of options.

Valid options are:

     -C <col>
      Sets the attribute index
      (default last).

     -L <label1,label2,...>
      Comma-separated list of labels to add.
      (default: none)

     -S
      Turns on the sorting of the labels.

Specified by:
  `setOptions` in interface `OptionHandler`
Parameters:
  `options` - the list of options as an array of strings
Throws:
  `Exception` - if an option is not supported

### getOptions

public String[] getOptions()
Gets the current settings of the filter.

Specified by:
  `getOptions` in interface `OptionHandler`
Returns:
  an array of strings suitable for passing to setOptions

### getCapabilities

public Capabilities getCapabilities()
Returns the Capabilities of this filter.

Specified by:
  `getCapabilities` in interface `CapabilitiesHandler`
Overrides:
  `getCapabilities` in class `Filter`
Returns:
  the capabilities of this object
See Also:
  - `Capabilities`

### setInputFormat

public boolean setInputFormat(Instances instanceInfo) throws Exception
Sets the format of the input instances.

Overrides:
  `setInputFormat` in class `Filter`
Parameters:
  `instanceInfo` - an Instances object containing the input instance structure (any instances contained in the object are ignored - only the structure is required).
Returns:
  true if the outputFormat may be collected immediately
Throws:
  `Exception` - if the input format can't be set successfully

### input

public boolean input(Instance instance)
Input an instance for filtering. The instance is processed and made available for output immediately.

Overrides:
  `input` in class `Filter`
Parameters:
  `instance` - the input instance
Returns:
  true if the filtered instance may now be collected with output().
Throws:
  `IllegalStateException` - if no input format has been set.

### attributeIndexTipText

public String attributeIndexTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### getAttributeIndex

public String getAttributeIndex()
Get the index of the attribute used.

Returns:
  the index of the attribute

### setAttributeIndex

public void setAttributeIndex(String attIndex)
Sets index of the attribute used.

Parameters:
  `attIndex` - the index of the attribute

### labelsTipText

public String labelsTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### getLabels

public String getLabels()
Get the comma-separated list of labels that are added.

Returns:
  the list of labels

### setLabels

public void setLabels(String value)
Sets the comma-separated list of labels.

Parameters:
  `value` - the list

### sortTipText

public String sortTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### getSort

public boolean getSort()
Gets whether the labels are sorted or not.

Returns:
  true if the labels are sorted

### setSort

public void setSort(boolean value)
Sets whether the labels are sorted.

Parameters:
  `value` - if true the labels are sorted

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Overrides:
  `getRevision` in class `Filter`
Returns:
  the revision

### main

public static void main(String[] args)
Main method for testing and running this class.

Parameters:
  `args` - should contain arguments to the filter: use -h for help